unit WebModuleUnit1;

interface

uses
  BookshelfModule,
  System.Rtti,
  System.SysUtils,
  System.Classes,
  Web.HTTPApp,
  WinApi.Windows,
  GraphQL.WebBroker;

type
  TWebModule1 = class(TWebModule)
    GraphQLWebBrokerDispatcher1: TGraphQLWebBrokerDispatcher;
    procedure WebModuleBeforeDispatch(Sender: TObject; Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
  end;

var
  WebModuleClass: TComponentClass = TWebModule1;

implementation

uses
  IdHTTPWebBrokerBridge,
  IdCustomHTTPServer;

{%CLASSGROUP 'Vcl.Controls.TControl'}

{$R *.dfm}

{ TWebModule1 }

type
  TLocalHttpRequest = class(TIdHTTPAppRequest)
  end;

procedure TWebModule1.WebModuleBeforeDispatch(Sender: TObject; Request: TWebRequest; Response: TWebResponse;
  var Handled: Boolean);
var
  Info: TIdHTTPRequestInfo;
begin
  Info := TLocalHttpRequest(Request).FRequestInfo;

  if not Info.AuthExists then
  begin
    Handled := True;
    Response.StatusCode := 401;
    Response.WWWAuthenticate := 'Bearer';
    Response.ContentType := 'text/plain';
    Response.Content := 'JWT not provided';
    Response.SendResponse;
  end;
end;

end.
